package com.image_scaler_v2
{
	
	import flash.display.*;
	import flash.net.*;
	import flash.events.*;
	import flash.geom.Rectangle;
	import flash.errors.*;
    import flash.filters.BevelFilter;
    import flash.filters.BitmapFilter;
    import flash.filters.BitmapFilterQuality;
    import flash.filters.BitmapFilterType;
	import flash.text.*;
	import flash.utils.*;
    import flash.filters.DropShadowFilter;
	
	public class Image_asset extends MovieClip
	{
		
        private var _mc, _image, _control:MovieClip;
		private var _mask, _cover,_label_back: MovieClip;
		private var _xml:XML;
		private var _width,_height,_pixel_width,_count,_ax,_ay:Number;
		private var _loaded:Boolean = false;
		private var _included:Boolean = true;
		private var _offscreen:Boolean = true;
		private var _fade_dir,_fade_count:Number;
		private var _label: TextField;
		
		
		public function Image_asset($c:MovieClip,$xml:XML,$count:Number):void
		{
			_mc = this;
			_count = $count;
			_mc.visible = false;
			_image = new MovieClip();
			_mc.addChild(_image);
			_mask = new MovieClip();
			_mc.addChild(_mask);
			_xml = $xml;
			var dw = parseFloat(_xml.pixel_width_int[0].toString());
			var dh = parseFloat(_xml.pixel_height_int[0].toString());
			_mask.graphics.beginFill(0x000000,1);
			var radius;
			if (dw>dh)
			{
				_width = 522;
				_height = 522*dh/dw;
				radius = _height/2;
			}
			else
			{
				_height = 522;
				_width = 522*dw/dh;
				radius = _width/2;
			}
			_image.x = -_width/2;
			_image.y = -_height/2;
			_label_back = new MovieClip();
			_mc.addChild(_label_back);
			_label = new TextField();
			_label.autoSize = TextFieldAutoSize.CENTER;
			_label.background = false;
			_label.border = false;
			var format:TextFormat = new TextFormat();
			format.font = "Arial";
			format.color = 0xffffff;
			format.size = 48;
			format.underline = false;
			_label.defaultTextFormat = format;
			_label.text = _xml.title_txt[0].toString();
			//_label.x = 10;
			_label.alpha = 0;
			_label.visible = false;
			_mc.addChild(_label);
			_cover = new MovieClip();
			_mc.addChild(_cover);
			_control = $c;
			_cover.graphics.beginFill(0x000000,1);
			_cover.addEventListener(MouseEvent.CLICK,show_image);
			_cover.addEventListener(MouseEvent.MOUSE_OVER,show_label);
			_cover.addEventListener(MouseEvent.MOUSE_OUT,hide_label);
			_label.x = -radius+10;
			_label.width = radius*2 - 20;
			_label.wordWrap = true;
			_label.y = -_label.height/2;
			_label_back.graphics.beginFill(0x000000,0.7);
			_label_back.graphics.drawRect(-radius,_label.y,2*radius,_label.height);
			_label_back.graphics.endFill();
			_label_back.alpha = 0;
			_label_back.visible = false;
            /*var filter:BitmapFilter = getBitmapFilter();
            var myFilters:Array = new Array();
            myFilters.push(filter);
            _label.filters = myFilters;*/
			_mask.graphics.drawRoundRect(-radius,-radius,2*radius,2*radius,120);
			_cover.graphics.drawRoundRect(-radius,-radius,2*radius,2*radius,120);
			_image.mask = _mask;
			_image.x = -Math.floor(_width/2);
			_image.y = -Math.floor(_height/2);
			_pixel_width = parseFloat(_xml.scale_width_float[0].toString())/_width;
			_load_image();
		}
		
		private function _load_image():void
		{
			var v = imageFromLib(_xml.filename_txt[0].toString());
			var bmp1:Bitmap = new Bitmap(v);
			_image.addChild(bmp1);//_xml.filename_txt[0].toString()));
			_load_complete(null);
		}
		
		private function imageFromLib(source_ID:String):BitmapData
		{
			var classRef:Class = getDefinitionByName(source_ID) as Class;
			return new classRef(classRef.width, classRef.height);
		}
		
        private function _configureListeners(dispatcher:IEventDispatcher):void
		{
            dispatcher.addEventListener(Event.INIT, _load_complete);
        }

		private function _load_complete($evt:Event):void
		{
			_mc.x = (_count%5)*90 - 180;
			_loaded = true;
		}
		
		private function _to_top($evt:MouseEvent):void
		{
			var p = _mc.parent;
			p.setChildIndex(_mc,p.numChildren-1);
		}
		
		private function _start_drag($evt:MouseEvent):void
		{
			var r = new Rectangle(-180,_mc.y,360,0);
			_mc.startDrag(false,r);
			stage.addEventListener(MouseEvent.MOUSE_UP,_stop_drag);
		}
		
		private function _stop_drag($evt:MouseEvent):void
		{
			_mc.stopDrag();
			stage.removeEventListener(MouseEvent.MOUSE_UP,_stop_drag);
		}
		
		public function reposition($maxsize,$minsize:Number):void
		{
			if (_loaded)
			{
				if ((_pixel_width>$minsize)&&(_pixel_width<$maxsize))
				{
					_offscreen = false;
					//var dist = Math.round((Math.log(_pixel_width/$minsize)/Math.LN10)*192);
					var dist = 1300*Math.pow(_pixel_width/$maxsize,1.3);
					var a = (80-dist)/80;
					if (a<0) a=0;
					if (a>1) a=1;
					_cover.alpha = a;
					var b = 1 - (Math.abs(300-dist)/200);
					_label_back.visible = true;
					_label.visible = true;
					if (b<0)
					{
						b = 0;
						_label_back.visible = false;
						_label.visible = false;
					}
					if (b>1) b = 1;
					_label_back.alpha = b;
					_label.alpha = b;
					_mc.x = _ax*dist;
					_mc.y = _ay*dist;
					_mc.scaleX = _mc.scaleY = 1.2*(_pixel_width/$maxsize);
					//_mc.y = 768 - Math.round((Math.log(_pixel_width/$minsize)/Math.LN10)*384);
					if (y<50)
					{
						_mc.scaleY *= 1;
					}
					else
					{
						_mc.scaleY *= 1;
					}
					if (_included) _mc.visible = true;
					else _mc.visible = false;
				}
				else
				{
					_offscreen = true;
					_mc.visible = false;
				}
			}
			else
			{
				_mc.visible = false;
			}
		}
		
		public function set included($val:Boolean):void
		{
			if (($val!=_included)&&(!_offscreen))
			{
				if ($val == true)
				{
					_fade_dir = 1;
					_fade_count = 0;
					_mc.alpha = 0.0;
					_mc.visible = true;
				}
				else
				{
					_fade_dir = -1;
					_fade_count = 10;
					_mc.alpha = 1.0;
					_mc.visible = true;
				}
				_mc.addEventListener(Event.ENTER_FRAME,_do_fade);
			}
			_included = $val;
		}
		
		public function select_by_string($a:Array):Boolean
		{
			for (var i=0; i<_xml.browse_items_list[0].browse_item_txt.length(); i++)
			{
				for (var j=0; j<$a.length; j++)
				{
					if (_xml.browse_items_list[0].browse_item_txt[i].toString().toLowerCase()==$a[j].toLowerCase())
					{
						_mc.included = true;
						return true;
					}
				}
			}
			_mc.included = false;
			return false;
		}
		
		private function _do_fade($evt:Event):void
		{
			_fade_count += _fade_dir;
			_mc.alpha = _fade_count/10;
			//trace(_fade_count);
			if (_fade_count <= 0)
			{
				//_mc.visible = false;
				_mc.removeEventListener(Event.ENTER_FRAME,_do_fade);
			}
			if (_fade_count >= 10)
			{
				_mc.removeEventListener(Event.ENTER_FRAME,_do_fade);
			}
		}
		
		public function get pixel_width():Number
		{
			return _pixel_width;
		}
		
		public function get quad():Number
		{
			return parseInt(_xml.quad[0].toString());
		}
		
		/*public function set count($c:Number)
		{
			_count = $c;
			var _base = parseInt(_xml.quad[0].toString());
			_ax = Math.cos(Math.PI*0.5*(_base+0.5 + ((_count%5)-2)*0.1));
			_ay = Math.sin(Math.PI*0.5*(_base+0.5+((_count%5)-4)*0.1));
			//_ay = Math.sin(Math.PI*2*_count/1.78);
		}*/

		public function set count($c:Number)
		{
			_count = $c;
			var _base = parseInt(_xml.quad[0].toString());
			_ax = Math.cos(Math.PI*0.5*(_base+0.5 + ((_count%4)-2)*0.3));
			_ay = Math.sin(Math.PI*0.5*(_base+0.5+((_count%4)-2)*0.3));
			//_ay = Math.sin(Math.PI*2*_count/1.78);
		}


        private function getBitmapFilter():BitmapFilter {
            var color:Number = 0x000000;
            var angle:Number = 45;
            var alpha:Number = 0.8;
            var blurX:Number = 4;
            var blurY:Number = 4;
            var distance:Number = 0;
            var strength:Number = 2;
            var inner:Boolean = false;
            var knockout:Boolean = false;
            var quality:Number = BitmapFilterQuality.HIGH;
            return new DropShadowFilter(distance,
                                        angle,
                                        color,
                                        alpha,
                                        blurX,
                                        blurY,
                                        strength,
                                        quality,
                                        inner,
                                        knockout);
        }
		public function hide_label($evt:Event):void
		{
			_mc.removeEventListener(Event.ENTER_FRAME,_label_fade_in);
			if (_label.alpha>0) _mc.addEventListener(Event.ENTER_FRAME,_label_fade_out);
		}
		
		public function show_label($evt:Event):void
		{
			_label.visible = true;
			_mc.removeEventListener(Event.ENTER_FRAME,_label_fade_out);
			if (_label.alpha<1) _mc.addEventListener(Event.ENTER_FRAME,_label_fade_in);
		}
		
		public function show_image($evt:Event):void
		{
			_control.show_image(_xml);
		}
		
		private function _label_fade_out($evt:Event)
		{
			var a = _label.alpha;
			a-=0.1;
			if (a<0)
			{
				a=0;
				_mc.removeEventListener(Event.ENTER_FRAME,_label_fade_out);
				_label.visible = false;
			}
			_label_back.alpha = a;
			_label.alpha = a;
		}

		private function _label_fade_in($evt:Event)
		{
			var a = _label.alpha;
			a+=0.1;
			if (a>1)
			{
				a=1;
				_mc.removeEventListener(Event.ENTER_FRAME,_label_fade_in);
			}
			_label_back.alpha = a;
			_label.alpha = a;
		}

 
	}
}
